%{!?_x_libraries:%global _x_libraries %{_libdir}}
%{!?_x_bindir:%global _x_bindir %{_bindir}}

%define _pkglibdir %{_libdir}/nx
%define _pkgdatadir %{_datadir}/nx
%define _pkglibexecdir %{_libexecdir}/nx

Summary: Proxy system for X11
Name: nx
Version: 2.1.0
Release: 22%{?dist}
License: GPL, MIT/X11 for X11 bits
Group: Applications/Internet
URL: http://www.nomachine.com
# Compression Libraries and Proxy Sources
Source0: http://www.nomachine.com/download/%{version}/sources/nxproxy-%{version}-3.tar.gz
Source1: http://www.nomachine.com/download/%{version}/sources/nxcomp-%{version}-7.tar.gz
Source2: http://www.nomachine.com/download/%{version}/sources/nxcompext-%{version}-5.tar.gz
# X11 Support Programs and Libraries
Source3: http://www.nomachine.com/download/%{version}/sources/nx-X11-%{version}-3.tar.gz
# X11 Agent Sources
Source4: http://www.nomachine.com/download/%{version}/sources/nxagent-%{version}-18.tar.gz
# RFB Agent Sources
Source5: http://www.nomachine.com/download/%{version}/sources/nxviewer-%{version}-12.tar.gz
# RDP Agent Sources
Source6: http://www.nomachine.com/download/%{version}/sources/nxdesktop-%{version}-10.tar.gz
# NX Example Scripts
Source7: http://www.nomachine.com/download/%{version}/sources/nxscripts-%{version}-5.tar.gz

Source8: nxwrapper.in
Source9: docs.tar.bz2

Source11: nxfind-provides.sh

%define _use_internal_dependency_generator 0
%define __find_provides %{SOURCE11}

Patch0: nx-2.1.0-fixes.patch
Patch1: NX-noansi.diff
Patch2: p_XFree86-4.3-ppc64.diff
Patch3: nxagent-64bit-clean.diff

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gcc-c++, redhat-release
BuildRequires: expat-devel, audiofile-devel, openssl-devel, libjpeg-devel, libpng-devel
BuildRequires: libXt-devel, xorg-x11-proto-devel, libXp-devel, imake
# Better mention what we really require on a file basis.
# Requires: xorg-x11-utils


%description
NX provides a proxy system for the X Window System.

%prep
%setup -q -c %{name}-%{version} -T -a0 -a1 -a2 -a3 -a4 -a5 -a6 -a7
%patch0 -p0 -b .fixes
pushd nx-X11
%patch1 -p0
%ifarch ppc64
%patch2 -p1
%endif
popd
%patch3 -p0
ln -s rdesktop.1 nxdesktop/doc/nxdesktop.1
export CFLAGS="%{optflags}"
%ifarch x86_64
export CFLAGS="$CFLAGS -fPIC"
%endif
cat >> nx-X11/config/cf/host.def << EOF
#ifdef i386Architecture
#undef DefaultGcc2i386Opt
#define DefaultGcc2i386Opt $CFLAGS -fno-strict-aliasing
#endif
#ifdef MipsArchitecture
#undef DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt $CFLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $CFLAGS -fno-strict-aliasing
#endif
EOF
export CXXFLAGS="$CFLAGS"
perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=\"$CXXFLAGS\"|" */configure

%build
export CFLAGS="%{optflags}"
%ifarch x86_64
export CFLAGS="$CFLAGS -fPIC"
%endif
export CXXFLAGS="$CFLAGS"

# build Compression Library and Proxy
for i in nxcomp nxproxy; do
  pushd $i; ./configure; make CCFLAGS="$CFLAGS"; popd
done
# build X11 Support Libraries and Agents
pushd nx-X11
  make World
popd
# build Extended Compression Library
pushd nxcompext
  ./configure; make
popd
# build RFB Agent
pushd nxviewer
  xmkmf -a
  cp -a %{_x_libraries}/libXp.so* ../nx-X11/exports/lib/
  make
popd
# build RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  ./configure --prefix=%{_prefix} --sharedir=%{_pkgdatadir}
  make
popd
%endif

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_pkglibdir}
mkdir -p %{buildroot}%{_pkglibexecdir}
mkdir -p %{buildroot}%{_mandir}/man1

# install X11 Support Libraries and Agents
install -p -m 0755 nx-X11/lib/X11/libX11.so.* \
   nx-X11/lib/Xext/libXext.so.* \
   nx-X11/lib/Xrender/libXrender.so.* \
   %{buildroot}%{_pkglibdir}
install -p -m 0755 nx-X11/programs/Xserver/nxagent \
  %{buildroot}%{_pkglibexecdir}
# nxwrapper
sed -e's,@PKGLIBDIR@,%{_pkglibdir},g' \
    -e's,@PKGLIBEXECDIR@,%{_pkglibexecdir},g' \
  < %{SOURCE8} > %{buildroot}%{_bindir}/nxwrapper
chmod 0755 %{buildroot}%{_bindir}/nxwrapper
ln -s nxwrapper %{buildroot}%{_bindir}/nxagent
# install Compression Libraries and Proxy
install -p -m 0755 nxcomp/libXcomp.so.* %{buildroot}%{_pkglibdir}
install -p -m 0755 nxcompext/libXcompext.so.* %{buildroot}%{_pkglibdir}
install -p -m 0755 nxproxy/nxproxy %{buildroot}%{_pkglibexecdir}
ln -s nxwrapper %{buildroot}%{_bindir}/nxproxy
# install RFB Agent
pushd nxviewer
  make install DESTDIR=%{buildroot}
  mv %{buildroot}%{_x_bindir}/nxviewer %{buildroot}%{_pkglibexecdir}
  ln -s nxwrapper %{buildroot}%{_bindir}/nxviewer
  chmod 755 %{buildroot}%{_bindir}/nxviewer
  if [ "%{_x_bindir}" != "%{_bindir}" ]; then
    mv %{buildroot}%{_x_bindir}/nxpasswd %{buildroot}%{_bindir}
  fi
popd
# install RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  make install DESTDIR=%{buildroot}
  mv %{buildroot}%{_bindir}/nxdesktop %{buildroot}%{_pkglibexecdir}
  ln -s nxwrapper %{buildroot}%{_bindir}/nxdesktop
  mv %{buildroot}/usr/man/man1/nxdesktop.1 \
    %{buildroot}%{_mandir}/man1/nxdesktop.1
  rm -rf %{buildroot}/usr/man
popd
%endif
# install scripts
mkdir -p %{buildroot}%{_defaultdocdir}/%{name}-%{version}
cp -a nxscripts %{buildroot}%{_defaultdocdir}/%{name}-%{version}
# documentation and license
tar xjf %{SOURCE9} -C %{buildroot}%{_defaultdocdir}/%{name}-%{version}
install -m 644 nxcomp/LICENSE %{buildroot}%{_defaultdocdir}/%{name}-%{version}
for i in nxcomp nxdesktop; do
  mkdir %{buildroot}%{_defaultdocdir}/%{name}-%{version}/$i
done
install -p -m 0644 nxcomp/README \
  %{buildroot}%{_defaultdocdir}/%{name}-%{version}/nxcomp/
install -p -m 0644 nxdesktop/README \
  %{buildroot}%{_defaultdocdir}/%{name}-%{version}/nxdesktop/
rm -rf nxdesktop/doc/CVS
cp -ar nxdesktop/doc/* \
  %{buildroot}%{_defaultdocdir}/%{name}-%{version}/nxdesktop/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/%{name}-%{version}
%{_bindir}/*
%{_pkglibdir}
%{_pkglibexecdir}
%ifnarch ppc ppc64 s390 s390x
%{_pkgdatadir}
%{_mandir}/man1/nxdesktop.1.gz
%endif

%changelog
* Fri Jun  1 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.1.0-22
- Sync with ATrpms' nxfindprovides helper.

* Wed May 23 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.1.0-21.1
- Fix typo in nxwrapper.in (PKGEXECDIR -> PKGLIBEXECDIR).

* Tue May 22 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.1.0-20
- readded Source11 to filter find-provides from showing libraries that
  should not be provided to the system. BZ#194652 & 240835.

* Mon Feb 19 2007 Axel Thimm <Axel.Thimm@ATrpms.net> - 2.1.0-18
- Update to 2.1.0 (4th? maintenance release).

* Tue Jan 17 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to maintenance release.

* Sat Jul 30 2005 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to nx 1.5.0. final.

* Mon Feb 14 2005 Rick Stout <zipsonic[AT]gmail.com> - 4:1.4.0
- updated nx-X11, nxproxy, nxcomp, nxagent and nxdesktop
- released to address X11 security concerns.

* Tue Nov 09 2004 Rick Stout <zipsonci[AT]gmail.com> - 3:1.4.0
- updated to 1.4.0 final

* Mon Oct 11 2004 Rick Stout <zipsonic[AT]gmail.com> - 2:1.4.0
- Changed naming structure to be more friendly (lowercase)

* Fri Oct 07 2004 Rick Stout <zipsonic[AT]gmail.com> - 1:1.4.0
- Updated package dependencies

* Wed Sep 29 2004 Rick Stout <zipsonic[AT]gmail.com> - 0:1.4.0
- Initial Fedora RPM release.
- Updated SuSE package to work with Fedora
